﻿@using GridMvc.Html
@using GridMvc.Sorting
@model Grid.Mvc.Ajax.GridExtensions.AjaxGrid<LoyaltyPointEngine.Model.Object.Receipt.ReceiptReportingModel>

@Html.Grid(Model).Named("AllReceipt").Columns(columns =>
{
    columns.Add(x => x.MemberName)
        .Titled("Member")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.MemberName);

    columns.Add(x => x.MemberPhone)
        .Titled("Member Phone")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.MemberPhone);

    columns.Add(x => x.Code)
        .Titled("Code")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.Code);

    columns.Add(x => x.ReceiptCode)
        .Titled("Receipt Code")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.ReceiptCode);

    columns.Add(x => x.Channel)
        .Titled("Channel")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.Channel);

    columns.Add(x => x.SPG)
        .Titled("Elina Code")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.SPG);

    columns.Add(x => x.TransactionDateDate)
        .Titled("TransactionDate")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.TransactionDateDate.HasValue ? x.TransactionDateDate.Value.ToString("dd-MM-yyyy HH:mm:ss") : string.Empty);

    columns.Add(x => x.Product)
        .Titled("Product")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.Product);

    columns.Add(x => x.Quantity)
        .Titled("Quantity")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.Quantity.ToString());

    columns.Add(x => x.RetailerName)
        .Titled("Retailer")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.RetailerName);

    columns.Add(x => x.RetailerAddress)
        .Titled("Retailer Address")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.RetailerAddress);

    columns.Add(x => x.Status)
        .Titled("Status")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => RenderStatus(x.Status));

    columns.Add(x => x.Reason)
         .Titled("Reject Reason")
         .Encoded(false)
         .Sanitized(false)
         .Sortable(true)
         .RenderValueAs(x=>x.Reason);

    columns.Add(x => x.Remarks)
        .Titled("Remarks")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.Remarks);

    columns.Add(x => x.Point)
        .Titled("Point")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true);

    columns.Add(x => x.CodeGimmick)
        .Titled("Code Gimmick")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.CodeGimmick);

    columns.Add(x => x.CreatedBy)
        .Titled("Registered By")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.CreatedBy);

    columns.Add(x => x.CreatedDate)
        .Titled("Created Date")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.CreatedDate.ToString("dd-MM-yyyy HH:mm"));

    columns.Add(x => x.UpdatedBy)
        .Titled("Updated By")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.UpdatedBy);

    columns.Add(x => x.UpdatedDate)
        .Titled("Updated Date")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.UpdatedDate.HasValue ? x.UpdatedDate.Value.ToString("dd-MM-yyyy HH:mm") : string.Empty);

    columns.Add(x => x.RequestDate)
        .Titled("Request Date")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.RequestDate.HasValue ? x.RequestDate.Value.ToString("dd-MM-yyyy HH:mm") : string.Empty);

    //columns.Add(x => x.IsApproved)
    //    .Titled("Approve Status")
    //    .Encoded(false)
    //    .Sanitized(false)
    //    .Sortable(true)
    //    .RenderValueAs(x => x.IsApproved);

    //columns.Add(x => x.IsDeleted)
    //    .Titled("Delete Status")
    //    .Encoded(false)
    //    .Sanitized(false)
    //    .Sortable(true)
    //    .RenderValueAs(x => x.IsDeleted);

}).Sortable().WithPaging(5)

<h3 id="totalRows">@String.Format("{0} rows", ViewData.Model.GridItems.Count().ToString())</h3>

@helper RenderStatus(int StatusID)
{
    string status = Enum.GetName(typeof(Receipt.ReceiptStatus), StatusID);
    string statusclass = string.Empty;
    if (status == Receipt.ReceiptStatus.Reject.ToString())
    {
        statusclass = "alert-danger";
    }
    else if (status == Receipt.ReceiptStatus.Waiting.ToString())
    {
        statusclass = "alert-warning";
    }
    else
    {
        statusclass = "alert-success";
    }
    <span class="@statusclass">
        @status
    </span>
}